<?php
/**
 * Author: [ CopyLian ]
 * Date: [ 2017.02.23 ]
 * Email: [ copylian@aikehou.com ]
 * Site: [ http://www.copylian.com ]
 * Description [ 文件下载类 ]
 */
namespace download;
class Download
{
	//文件名称
	protected $_filename;

	//文件路径
    protected $_filepath;

    /**
     * [__construct 构造方法]
     * @param [type] $filename [文件名称]
     * @param [type] $curpath [文件路径]
     */
    public function __construct($curpath = '', $filename = ''){
    	//文件名称
        $this->_filename = $filename;

        //文件全部路径
        $this->_filepath = $curpath . $filename;
    }

    /**
     * [getfiles 下载文件]
     */
    public function getfiles(){
        //检查文件是否存在
        if (file_exists($this->_filepath)){

            //打开文件
            $file = fopen($this->_filepath, "r");

            //返回的文件类型
            Header("Content-type: application/octet-stream");

            //按照字节大小返回
            Header("Accept-Ranges: bytes");

            //返回文件的大小
            Header("Accept-Length: " . filesize($this->_filepath));

            //这里对客户端的弹出对话框，对应的文件名
            Header("Content-Disposition: attachment; filename=" . $this->_filename);

            //修改之前，一次性将数据传输给客户端
            echo fread($file, filesize($this->_filepath));

            //修改之后，一次只传输1024个字节的数据给客户端
            //向客户端回送数据
            $buffer = 1024;

            //判断文件是否读完
            while (!feof($file)) {
                //将文件读入内存
                $file_data = fread($file, $buffer);

                //每次向客户端回送1024个字节的数据
                echo $file_data;
            }
            
            fclose($file);
        } else {
            echo lang('l_file_notexists');
        }
    }
}
?>